package it.univaq.di.choreos.coordinationprotocol.algorithm;

import it.univaq.di.choreos.coordinationprotocol.algorithm.model.AdditionalMessage;
import it.univaq.di.choreos.coordinationprotocol.algorithm.model.ContextData;
import it.univaq.di.choreos.coordinationprotocol.algorithm.model.CoordinationDelegateID;
import it.univaq.di.choreos.coordinationprotocol.algorithm.model.coordmetamodel.AllowedOperation;
import it.univaq.di.choreos.coordinationprotocol.algorithm.model.coordmetamodel.Participant;

public interface CoordinationDelegateAlgorithm {

	void handleRules(AllowedOperation request, Participant coordinationDelegateFrom, ForwardAndDiscardMessagesCallback messagesCallback, ContextData contextData);

	void receiveUpdateCurrentState(AdditionalMessage additionalMessage);
	
	CoordinationDelegateID getId();

	void setId(CoordinationDelegateID id);

}