package it.univaq.di.choreos.coordinationprotocol.algorithm.impl;

import it.univaq.di.choreos.coordinationprotocol.algorithm.CoordinationDelegateAlgorithm;
import it.univaq.di.choreos.coordinationprotocol.algorithm.ForwardAndDiscardMessagesCallback;
import it.univaq.di.choreos.coordinationprotocol.algorithm.model.AdditionalMessage;
import it.univaq.di.choreos.coordinationprotocol.algorithm.model.ContextData;
import it.univaq.di.choreos.coordinationprotocol.algorithm.model.CoordinationDelegateID;
import it.univaq.di.choreos.coordinationprotocol.algorithm.model.coordmetamodel.AllowedOperation;
import it.univaq.di.choreos.coordinationprotocol.algorithm.model.coordmetamodel.Participant;

public class DummyCoordinationDelegateAlgorithmImpl implements CoordinationDelegateAlgorithm {
	
	private CoordinationDelegateID id = new CoordinationDelegateID();

	public void handleRules(AllowedOperation request, Participant coordinationDelegateFrom, ForwardAndDiscardMessagesCallback messagesCallback, ContextData contextData) {
		messagesCallback.forwardMessage(contextData);
	}


	@Override
	public void receiveUpdateCurrentState(AdditionalMessage additionalMessage) {
		
	}

	public CoordinationDelegateID getId() {
		return id;
	}

	public void setId(CoordinationDelegateID id) {
		this.id = id;
	}

}
