/**
 */
package it.univaq.di.choreos.coordinationprotocol.algorithm.model.coordmetamodel.impl;

import it.univaq.di.choreos.coordinationprotocol.algorithm.model.coordmetamodel.AllowedOperation;
import it.univaq.di.choreos.coordinationprotocol.algorithm.model.coordmetamodel.Condition;
import it.univaq.di.choreos.coordinationprotocol.algorithm.model.coordmetamodel.CoordmetamodelPackage;
import it.univaq.di.choreos.coordinationprotocol.algorithm.model.coordmetamodel.Notify;
import it.univaq.di.choreos.coordinationprotocol.algorithm.model.coordmetamodel.Participant;
import it.univaq.di.choreos.coordinationprotocol.algorithm.model.coordmetamodel.State;
import it.univaq.di.choreos.coordinationprotocol.algorithm.model.coordmetamodel.Tuple;
import it.univaq.di.choreos.coordinationprotocol.algorithm.model.coordmetamodel.Wait;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.impl.EObjectImpl;

import org.eclipse.emf.ecore.util.EObjectResolvingEList;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Tuple</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link it.univaq.di.choreos.coordinationprotocol.algorithm.model.coordmetamodel.impl.TupleImpl#getSourceState <em>Source State</em>}</li>
 *   <li>{@link it.univaq.di.choreos.coordinationprotocol.algorithm.model.coordmetamodel.impl.TupleImpl#getAllowedOperation <em>Allowed Operation</em>}</li>
 *   <li>{@link it.univaq.di.choreos.coordinationprotocol.algorithm.model.coordmetamodel.impl.TupleImpl#getTargetState <em>Target State</em>}</li>
 *   <li>{@link it.univaq.di.choreos.coordinationprotocol.algorithm.model.coordmetamodel.impl.TupleImpl#getAllowedComponentInTargetState <em>Allowed Component In Target State</em>}</li>
 *   <li>{@link it.univaq.di.choreos.coordinationprotocol.algorithm.model.coordmetamodel.impl.TupleImpl#getCondition <em>Condition</em>}</li>
 *   <li>{@link it.univaq.di.choreos.coordinationprotocol.algorithm.model.coordmetamodel.impl.TupleImpl#getNotify <em>Notify</em>}</li>
 *   <li>{@link it.univaq.di.choreos.coordinationprotocol.algorithm.model.coordmetamodel.impl.TupleImpl#getWait <em>Wait</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class TupleImpl extends EObjectImpl implements Tuple {
	/**
	 * The cached value of the '{@link #getSourceState() <em>Source State</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getSourceState()
	 * @generated
	 * @ordered
	 */
	protected State sourceState;

	/**
	 * The cached value of the '{@link #getAllowedOperation() <em>Allowed Operation</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getAllowedOperation()
	 * @generated
	 * @ordered
	 */
	protected AllowedOperation allowedOperation;

	/**
	 * The cached value of the '{@link #getTargetState() <em>Target State</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getTargetState()
	 * @generated
	 * @ordered
	 */
	protected State targetState;

	/**
	 * The cached value of the '{@link #getAllowedComponentInTargetState() <em>Allowed Component In Target State</em>}' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getAllowedComponentInTargetState()
	 * @generated
	 * @ordered
	 */
	protected EList<Participant> allowedComponentInTargetState;

	/**
	 * The cached value of the '{@link #getCondition() <em>Condition</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getCondition()
	 * @generated
	 * @ordered
	 */
	protected Condition condition;

	/**
	 * The cached value of the '{@link #getNotify() <em>Notify</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getNotify()
	 * @generated
	 * @ordered
	 */
	protected Notify notify;

	/**
	 * The cached value of the '{@link #getWait() <em>Wait</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getWait()
	 * @generated
	 * @ordered
	 */
	protected Wait wait;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected TupleImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return CoordmetamodelPackage.Literals.TUPLE;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public State getSourceState() {
		if (sourceState != null && sourceState.eIsProxy()) {
			InternalEObject oldSourceState = (InternalEObject)sourceState;
			sourceState = (State)eResolveProxy(oldSourceState);
			if (sourceState != oldSourceState) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, CoordmetamodelPackage.TUPLE__SOURCE_STATE, oldSourceState, sourceState));
			}
		}
		return sourceState;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public State basicGetSourceState() {
		return sourceState;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setSourceState(State newSourceState) {
		State oldSourceState = sourceState;
		sourceState = newSourceState;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, CoordmetamodelPackage.TUPLE__SOURCE_STATE, oldSourceState, sourceState));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public AllowedOperation getAllowedOperation() {
		if (allowedOperation != null && allowedOperation.eIsProxy()) {
			InternalEObject oldAllowedOperation = (InternalEObject)allowedOperation;
			allowedOperation = (AllowedOperation)eResolveProxy(oldAllowedOperation);
			if (allowedOperation != oldAllowedOperation) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, CoordmetamodelPackage.TUPLE__ALLOWED_OPERATION, oldAllowedOperation, allowedOperation));
			}
		}
		return allowedOperation;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public AllowedOperation basicGetAllowedOperation() {
		return allowedOperation;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setAllowedOperation(AllowedOperation newAllowedOperation) {
		AllowedOperation oldAllowedOperation = allowedOperation;
		allowedOperation = newAllowedOperation;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, CoordmetamodelPackage.TUPLE__ALLOWED_OPERATION, oldAllowedOperation, allowedOperation));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public State getTargetState() {
		if (targetState != null && targetState.eIsProxy()) {
			InternalEObject oldTargetState = (InternalEObject)targetState;
			targetState = (State)eResolveProxy(oldTargetState);
			if (targetState != oldTargetState) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, CoordmetamodelPackage.TUPLE__TARGET_STATE, oldTargetState, targetState));
			}
		}
		return targetState;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public State basicGetTargetState() {
		return targetState;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setTargetState(State newTargetState) {
		State oldTargetState = targetState;
		targetState = newTargetState;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, CoordmetamodelPackage.TUPLE__TARGET_STATE, oldTargetState, targetState));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<Participant> getAllowedComponentInTargetState() {
		if (allowedComponentInTargetState == null) {
			allowedComponentInTargetState = new EObjectResolvingEList<Participant>(Participant.class, this, CoordmetamodelPackage.TUPLE__ALLOWED_COMPONENT_IN_TARGET_STATE);
		}
		return allowedComponentInTargetState;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Condition getCondition() {
		return condition;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetCondition(Condition newCondition, NotificationChain msgs) {
		Condition oldCondition = condition;
		condition = newCondition;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, CoordmetamodelPackage.TUPLE__CONDITION, oldCondition, newCondition);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setCondition(Condition newCondition) {
		if (newCondition != condition) {
			NotificationChain msgs = null;
			if (condition != null)
				msgs = ((InternalEObject)condition).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - CoordmetamodelPackage.TUPLE__CONDITION, null, msgs);
			if (newCondition != null)
				msgs = ((InternalEObject)newCondition).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - CoordmetamodelPackage.TUPLE__CONDITION, null, msgs);
			msgs = basicSetCondition(newCondition, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, CoordmetamodelPackage.TUPLE__CONDITION, newCondition, newCondition));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Notify getNotify() {
		return notify;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetNotify(Notify newNotify, NotificationChain msgs) {
		Notify oldNotify = notify;
		notify = newNotify;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, CoordmetamodelPackage.TUPLE__NOTIFY, oldNotify, newNotify);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setNotify(Notify newNotify) {
		if (newNotify != notify) {
			NotificationChain msgs = null;
			if (notify != null)
				msgs = ((InternalEObject)notify).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - CoordmetamodelPackage.TUPLE__NOTIFY, null, msgs);
			if (newNotify != null)
				msgs = ((InternalEObject)newNotify).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - CoordmetamodelPackage.TUPLE__NOTIFY, null, msgs);
			msgs = basicSetNotify(newNotify, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, CoordmetamodelPackage.TUPLE__NOTIFY, newNotify, newNotify));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Wait getWait() {
		return wait;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetWait(Wait newWait, NotificationChain msgs) {
		Wait oldWait = wait;
		wait = newWait;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, CoordmetamodelPackage.TUPLE__WAIT, oldWait, newWait);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setWait(Wait newWait) {
		if (newWait != wait) {
			NotificationChain msgs = null;
			if (wait != null)
				msgs = ((InternalEObject)wait).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - CoordmetamodelPackage.TUPLE__WAIT, null, msgs);
			if (newWait != null)
				msgs = ((InternalEObject)newWait).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - CoordmetamodelPackage.TUPLE__WAIT, null, msgs);
			msgs = basicSetWait(newWait, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, CoordmetamodelPackage.TUPLE__WAIT, newWait, newWait));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String toString() {
		/*
		if (eIsProxy()) 
				return super.toString();
		
		
		
		StringBuilder result = new StringBuilder();
		
		result.append("Information=");
		result.append("[sourceState=");
		
		result.append(sourceState);
		
		result.append(", allowedOperation=");
		
		result.append(allowedOperation);
		
		result.append(", targetState=");
		
		result.append(targetState);
		
		result.append(", allowedComponentInSourceState=");
		
		result.append(allowedComponentInSourceState);
		
		result.append(", allowedComponentInTargetState=");
		
		result.append(allowedComponentInTargetState);
		
		result.append(", participantRole=");
		
		result.append(participantRole);
		result.append("]");
		
		return result.toString();*/
		return null;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case CoordmetamodelPackage.TUPLE__CONDITION:
				return basicSetCondition(null, msgs);
			case CoordmetamodelPackage.TUPLE__NOTIFY:
				return basicSetNotify(null, msgs);
			case CoordmetamodelPackage.TUPLE__WAIT:
				return basicSetWait(null, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case CoordmetamodelPackage.TUPLE__SOURCE_STATE:
				if (resolve) return getSourceState();
				return basicGetSourceState();
			case CoordmetamodelPackage.TUPLE__ALLOWED_OPERATION:
				if (resolve) return getAllowedOperation();
				return basicGetAllowedOperation();
			case CoordmetamodelPackage.TUPLE__TARGET_STATE:
				if (resolve) return getTargetState();
				return basicGetTargetState();
			case CoordmetamodelPackage.TUPLE__ALLOWED_COMPONENT_IN_TARGET_STATE:
				return getAllowedComponentInTargetState();
			case CoordmetamodelPackage.TUPLE__CONDITION:
				return getCondition();
			case CoordmetamodelPackage.TUPLE__NOTIFY:
				return getNotify();
			case CoordmetamodelPackage.TUPLE__WAIT:
				return getWait();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case CoordmetamodelPackage.TUPLE__SOURCE_STATE:
				setSourceState((State)newValue);
				return;
			case CoordmetamodelPackage.TUPLE__ALLOWED_OPERATION:
				setAllowedOperation((AllowedOperation)newValue);
				return;
			case CoordmetamodelPackage.TUPLE__TARGET_STATE:
				setTargetState((State)newValue);
				return;
			case CoordmetamodelPackage.TUPLE__ALLOWED_COMPONENT_IN_TARGET_STATE:
				getAllowedComponentInTargetState().clear();
				getAllowedComponentInTargetState().addAll((Collection<? extends Participant>)newValue);
				return;
			case CoordmetamodelPackage.TUPLE__CONDITION:
				setCondition((Condition)newValue);
				return;
			case CoordmetamodelPackage.TUPLE__NOTIFY:
				setNotify((Notify)newValue);
				return;
			case CoordmetamodelPackage.TUPLE__WAIT:
				setWait((Wait)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case CoordmetamodelPackage.TUPLE__SOURCE_STATE:
				setSourceState((State)null);
				return;
			case CoordmetamodelPackage.TUPLE__ALLOWED_OPERATION:
				setAllowedOperation((AllowedOperation)null);
				return;
			case CoordmetamodelPackage.TUPLE__TARGET_STATE:
				setTargetState((State)null);
				return;
			case CoordmetamodelPackage.TUPLE__ALLOWED_COMPONENT_IN_TARGET_STATE:
				getAllowedComponentInTargetState().clear();
				return;
			case CoordmetamodelPackage.TUPLE__CONDITION:
				setCondition((Condition)null);
				return;
			case CoordmetamodelPackage.TUPLE__NOTIFY:
				setNotify((Notify)null);
				return;
			case CoordmetamodelPackage.TUPLE__WAIT:
				setWait((Wait)null);
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case CoordmetamodelPackage.TUPLE__SOURCE_STATE:
				return sourceState != null;
			case CoordmetamodelPackage.TUPLE__ALLOWED_OPERATION:
				return allowedOperation != null;
			case CoordmetamodelPackage.TUPLE__TARGET_STATE:
				return targetState != null;
			case CoordmetamodelPackage.TUPLE__ALLOWED_COMPONENT_IN_TARGET_STATE:
				return allowedComponentInTargetState != null && !allowedComponentInTargetState.isEmpty();
			case CoordmetamodelPackage.TUPLE__CONDITION:
				return condition != null;
			case CoordmetamodelPackage.TUPLE__NOTIFY:
				return notify != null;
			case CoordmetamodelPackage.TUPLE__WAIT:
				return wait != null;
		}
		return super.eIsSet(featureID);
	}

} //TupleImpl
