package it.univaq.di.choreos.stockorder;

import it.univaq.di.choreos.stockbuy.client.StockBuy;
import it.univaq.di.choreos.stockbuy.client.StockBuy_Service;

import javax.jws.Oneway;
import javax.jws.WebMethod;
import javax.jws.WebParam;
import javax.jws.WebService;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

@WebService( serviceName="", targetNamespace="http://choreos.di.univaq.it", portName="StockOrderPort" )
public class StockOrder {

	final Logger logger = LoggerFactory.getLogger(StockOrder.class);
	
	@WebMethod( operationName="stockOrder" )
	@Oneway
	public void stockOrder( @WebParam( name="stockSymbol" ) String stockSymbol, @WebParam( name="maxPrice" ) float maxPrice, @WebParam( name="quantity" ) int quantity ) {
		logger.debug("begin stockOder");

		StockBuy_Service service = new StockBuy_Service();
		StockBuy stockBuy = service.getStockBuyPort();
		stockBuy.buy("", 10);
		logger.debug("end stockOder");		
	}
}
