package it.univaq.di.choreos.synthesis.behavioursimulator.rest;

import it.univaq.di.choreos.synthesis.Utility;
import it.univaq.di.choreos.synthesis.configuration.Configuration;
import it.univaq.di.choreos.synthesis.rest.RESTServer;

public class BehaviourSimulatorServer {

	public static String NAME;
	public static String URL;
	private RESTServer restServer;

	static {
		String port = Configuration.get(Configuration.SERVER_PORT);
		NAME = Configuration.get(Configuration.SERVER_NAME);
		URL = "http://" + Utility.getHostAddress() + ":" + port + "/behavioursimulator/";

	}

	public BehaviourSimulatorServer() {
		this.restServer = new RESTServer(NAME, URL, new Class[] { RestBehaviourSimulator.class });
	}

	public void start() {
		this.restServer.start();
	}

	public void stop() {
		this.restServer.stop();
	}

	public static void main(String[] args) throws InterruptedException {
		BehaviourSimulatorServer server = new BehaviourSimulatorServer();
		server.start();
	}
}
