package it.univaq.di.choreos.synthesis.synthesisprocessor.dummies.test01;

import java.util.ArrayList;
import java.util.List;

import it.univaq.di.choreos.synthesis.behavioursimulator.BehaviourSimulator;
import it.univaq.di.choreos.synthesis.behavioursimulator.BehaviourSimulatorException;
import it.univaq.di.choreos.synthesis.datamodel.CLTSModel;
import it.univaq.di.choreos.synthesis.datamodel.ELTSModel;

public class DummyBehaviourSimulator implements BehaviourSimulator {
	private boolean simulationResult;

	public DummyBehaviourSimulator(boolean simulationResult) {
		this.simulationResult = simulationResult;
	}

	public boolean simulation(ELTSModel firstELTSModel, ELTSModel secondELTSModel) throws BehaviourSimulatorException {
		return simulationResult;
	}

	public ELTSModel projection(CLTSModel cltsModel, String participantName) throws BehaviourSimulatorException {
		ELTSModel result = new ELTSModel();
		//result.setCltsModel(participantName);
		return result;
	}

	public List<ELTSModel> projections(CLTSModel cltsModel) throws BehaviourSimulatorException {
		List<ELTSModel> result = new ArrayList<ELTSModel>();
		return result;
	}

}
