package it.univaq.di.choreos.synthesis.synthesisprocessor.dummies.test01;

import it.univaq.di.choreos.synthesis.datamodel.Service;
import it.univaq.di.choreos.synthesis.datamodel.ServiceDiscoveryInput;
import it.univaq.di.choreos.synthesis.servicediscovery.ServiceDiscovery;
import it.univaq.di.choreos.synthesis.servicediscovery.ServiceDiscoveryException;

import java.util.List;
import java.util.Map;

public class DummyServiceDiscovery implements ServiceDiscovery {

	Map<String, List<Service>> services;

	public DummyServiceDiscovery(Map<String, List<Service>> services) {
		this.services = services;
	}

	public List<Service> discoverServices(ServiceDiscoveryInput serviceDiscoveryInput) throws ServiceDiscoveryException {
		return services.get(serviceDiscoveryInput.getParticipant());
	}

}
