package org.ow2.choreos.chordevelopment.analysis.depanalyzer.analysis.intra;

import org.ow2.choreos.chordevelopment.analysis.depanalyzer.entity.Participant;

public class Operation {

	private String operationName;
	private Participant participant;
	
	public Operation(String operationName, Participant participant){
		this.operationName = operationName;
		this.participant = participant;
	}

	protected String getOperationName() {
		return operationName;
	}

	protected Participant getParticipant() {
		return participant;
	}	
	
	@Override
	public boolean equals(Object o) {
		Operation otherOperation = (Operation)o;
		
		boolean sameOperationName = this.getOperationName().equals(
				otherOperation.getOperationName());
		
		boolean fromSameParticipant = this.getParticipant().equals(
				otherOperation.getParticipant());
		
		return sameOperationName && fromSameParticipant;
	}
}