package org.ow2.choreos.chordevelopment.analysis.depanalyzer.entity;


public class TaskStep extends Step{

	private String name;
	
	private Participant initiatingParticipant;
	private String initiatingMessage;
	private Participant targetParticipant;
	private String responseMessage;
	
	public TaskStep(String ID, Participant initiatingParticipant, 
			String initiatingMessage, String name,
			Participant targetParticipant,
			String responseMessage){
		
		this.ID = ID;		
		this.initiatingParticipant = initiatingParticipant;
		this.initiatingMessage = initiatingMessage;
		this.name = name;
		this.targetParticipant = targetParticipant;		
		this.responseMessage = responseMessage;
	}

	public String getName() {
		return name;
	}

	public Participant getInitiatingParticipant() {
		return initiatingParticipant;
	}

	public String getInitiatingMessage() {
		return initiatingMessage;
	}

	public Participant getTargetParticipant() {
		return targetParticipant;
	}

	public String getResponseMessage() {
		return responseMessage;
	}

	@Override
	protected void plugIntoChoreography(ChoreographySchema chorSchema) {
		chorSchema.addTaskStep(this);
	}
}
