/**
 */
package it.univaq.di.choreos.coordinationprotocol.algorithm.model.coordmetamodel.impl;

import it.univaq.di.choreos.coordinationprotocol.algorithm.model.coordmetamodel.AllowedOperation;
import it.univaq.di.choreos.coordinationprotocol.algorithm.model.coordmetamodel.Coord;
import it.univaq.di.choreos.coordinationprotocol.algorithm.model.coordmetamodel.CoordmetamodelPackage;
import it.univaq.di.choreos.coordinationprotocol.algorithm.model.coordmetamodel.Participant;
import it.univaq.di.choreos.coordinationprotocol.algorithm.model.coordmetamodel.State;
import it.univaq.di.choreos.coordinationprotocol.algorithm.model.coordmetamodel.Tuple;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.eclipse.emf.ecore.util.EObjectContainmentEList;
import org.eclipse.emf.ecore.util.InternalEList;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Coord</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link it.univaq.di.choreos.coordinationprotocol.algorithm.model.coordmetamodel.impl.CoordImpl#getTuples <em>Tuples</em>}</li>
 *   <li>{@link it.univaq.di.choreos.coordinationprotocol.algorithm.model.coordmetamodel.impl.CoordImpl#getStates <em>States</em>}</li>
 *   <li>{@link it.univaq.di.choreos.coordinationprotocol.algorithm.model.coordmetamodel.impl.CoordImpl#getOperations <em>Operations</em>}</li>
 *   <li>{@link it.univaq.di.choreos.coordinationprotocol.algorithm.model.coordmetamodel.impl.CoordImpl#getParticipants <em>Participants</em>}</li>
 *   <li>{@link it.univaq.di.choreos.coordinationprotocol.algorithm.model.coordmetamodel.impl.CoordImpl#getInitialState <em>Initial State</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class CoordImpl extends NamedElementImpl implements Coord {
	/**
	 * The cached value of the '{@link #getTuples() <em>Tuples</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getTuples()
	 * @generated
	 * @ordered
	 */
	protected EList<Tuple> tuples;

	/**
	 * The cached value of the '{@link #getStates() <em>States</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getStates()
	 * @generated
	 * @ordered
	 */
	protected EList<State> states;

	/**
	 * The cached value of the '{@link #getOperations() <em>Operations</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getOperations()
	 * @generated
	 * @ordered
	 */
	protected EList<AllowedOperation> operations;

	/**
	 * The cached value of the '{@link #getParticipants() <em>Participants</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getParticipants()
	 * @generated
	 * @ordered
	 */
	protected EList<Participant> participants;

	/**
	 * The cached value of the '{@link #getInitialState() <em>Initial State</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getInitialState()
	 * @generated
	 * @ordered
	 */
	protected State initialState;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected CoordImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return CoordmetamodelPackage.Literals.COORD;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<Tuple> getTuples() {
		if (tuples == null) {
			tuples = new EObjectContainmentEList<Tuple>(Tuple.class, this, CoordmetamodelPackage.COORD__TUPLES);
		}
		return tuples;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<State> getStates() {
		if (states == null) {
			states = new EObjectContainmentEList<State>(State.class, this, CoordmetamodelPackage.COORD__STATES);
		}
		return states;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<AllowedOperation> getOperations() {
		if (operations == null) {
			operations = new EObjectContainmentEList<AllowedOperation>(AllowedOperation.class, this, CoordmetamodelPackage.COORD__OPERATIONS);
		}
		return operations;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<Participant> getParticipants() {
		if (participants == null) {
			participants = new EObjectContainmentEList<Participant>(Participant.class, this, CoordmetamodelPackage.COORD__PARTICIPANTS);
		}
		return participants;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public State getInitialState() {
		if (initialState != null && initialState.eIsProxy()) {
			InternalEObject oldInitialState = (InternalEObject)initialState;
			initialState = (State)eResolveProxy(oldInitialState);
			if (initialState != oldInitialState) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, CoordmetamodelPackage.COORD__INITIAL_STATE, oldInitialState, initialState));
			}
		}
		return initialState;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public State basicGetInitialState() {
		return initialState;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setInitialState(State newInitialState) {
		State oldInitialState = initialState;
		initialState = newInitialState;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, CoordmetamodelPackage.COORD__INITIAL_STATE, oldInitialState, initialState));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String toString() {
		/*
		if (eIsProxy()) 
				return super.toString();
		
		
		
		StringBuilder result = new StringBuilder();
		
		result.append("Coord(");
		result.append(getName());
		result.append(")=");
		result.append("[informations=");
		
		result.append(informations);
		
		result.append(", states=");
		
		result.append(states);
		
		result.append(", operations=");
		
		result.append(operations);
		
		result.append(", roles=");
		
		result.append(roles);
		
		result.append(", participants=");
		
		result.append(participants);
		result.append("]");
		
		return result.toString();*/
		return null;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case CoordmetamodelPackage.COORD__TUPLES:
				return ((InternalEList<?>)getTuples()).basicRemove(otherEnd, msgs);
			case CoordmetamodelPackage.COORD__STATES:
				return ((InternalEList<?>)getStates()).basicRemove(otherEnd, msgs);
			case CoordmetamodelPackage.COORD__OPERATIONS:
				return ((InternalEList<?>)getOperations()).basicRemove(otherEnd, msgs);
			case CoordmetamodelPackage.COORD__PARTICIPANTS:
				return ((InternalEList<?>)getParticipants()).basicRemove(otherEnd, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case CoordmetamodelPackage.COORD__TUPLES:
				return getTuples();
			case CoordmetamodelPackage.COORD__STATES:
				return getStates();
			case CoordmetamodelPackage.COORD__OPERATIONS:
				return getOperations();
			case CoordmetamodelPackage.COORD__PARTICIPANTS:
				return getParticipants();
			case CoordmetamodelPackage.COORD__INITIAL_STATE:
				if (resolve) return getInitialState();
				return basicGetInitialState();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case CoordmetamodelPackage.COORD__TUPLES:
				getTuples().clear();
				getTuples().addAll((Collection<? extends Tuple>)newValue);
				return;
			case CoordmetamodelPackage.COORD__STATES:
				getStates().clear();
				getStates().addAll((Collection<? extends State>)newValue);
				return;
			case CoordmetamodelPackage.COORD__OPERATIONS:
				getOperations().clear();
				getOperations().addAll((Collection<? extends AllowedOperation>)newValue);
				return;
			case CoordmetamodelPackage.COORD__PARTICIPANTS:
				getParticipants().clear();
				getParticipants().addAll((Collection<? extends Participant>)newValue);
				return;
			case CoordmetamodelPackage.COORD__INITIAL_STATE:
				setInitialState((State)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case CoordmetamodelPackage.COORD__TUPLES:
				getTuples().clear();
				return;
			case CoordmetamodelPackage.COORD__STATES:
				getStates().clear();
				return;
			case CoordmetamodelPackage.COORD__OPERATIONS:
				getOperations().clear();
				return;
			case CoordmetamodelPackage.COORD__PARTICIPANTS:
				getParticipants().clear();
				return;
			case CoordmetamodelPackage.COORD__INITIAL_STATE:
				setInitialState((State)null);
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case CoordmetamodelPackage.COORD__TUPLES:
				return tuples != null && !tuples.isEmpty();
			case CoordmetamodelPackage.COORD__STATES:
				return states != null && !states.isEmpty();
			case CoordmetamodelPackage.COORD__OPERATIONS:
				return operations != null && !operations.isEmpty();
			case CoordmetamodelPackage.COORD__PARTICIPANTS:
				return participants != null && !participants.isEmpty();
			case CoordmetamodelPackage.COORD__INITIAL_STATE:
				return initialState != null;
		}
		return super.eIsSet(featureID);
	}

} //CoordImpl
