/**
 */
package it.univaq.di.choreos.ELTS.impl;

import it.univaq.di.choreos.ELTS.ActivityLoop;
import it.univaq.di.choreos.ELTS.Alternative;
import it.univaq.di.choreos.ELTS.DataTypeDefinition;
import it.univaq.di.choreos.ELTS.ELTSPackage;
import it.univaq.di.choreos.ELTS.EpsilonTransition;
import it.univaq.di.choreos.ELTS.FaultTypeDefinition;
import it.univaq.di.choreos.ELTS.FinalState;
import it.univaq.di.choreos.ELTS.Fork;
import it.univaq.di.choreos.ELTS.InitialState;
import it.univaq.di.choreos.ELTS.Join;
import it.univaq.di.choreos.ELTS.LabeledTransition;
import it.univaq.di.choreos.ELTS.Model;
import it.univaq.di.choreos.ELTS.OperationsDefinition;
import it.univaq.di.choreos.ELTS.State;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.impl.EObjectImpl;

import org.eclipse.emf.ecore.util.EObjectContainmentEList;
import org.eclipse.emf.ecore.util.InternalEList;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Model</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link it.univaq.di.choreos.ELTS.impl.ModelImpl#getStates <em>States</em>}</li>
 *   <li>{@link it.univaq.di.choreos.ELTS.impl.ModelImpl#getForks <em>Forks</em>}</li>
 *   <li>{@link it.univaq.di.choreos.ELTS.impl.ModelImpl#getJoins <em>Joins</em>}</li>
 *   <li>{@link it.univaq.di.choreos.ELTS.impl.ModelImpl#getLabeledTransitions <em>Labeled Transitions</em>}</li>
 *   <li>{@link it.univaq.di.choreos.ELTS.impl.ModelImpl#getEpsilonTransitions <em>Epsilon Transitions</em>}</li>
 *   <li>{@link it.univaq.di.choreos.ELTS.impl.ModelImpl#getInitialState <em>Initial State</em>}</li>
 *   <li>{@link it.univaq.di.choreos.ELTS.impl.ModelImpl#getFinalState <em>Final State</em>}</li>
 *   <li>{@link it.univaq.di.choreos.ELTS.impl.ModelImpl#getOperationsDefinition <em>Operations Definition</em>}</li>
 *   <li>{@link it.univaq.di.choreos.ELTS.impl.ModelImpl#getAlternatives <em>Alternatives</em>}</li>
 *   <li>{@link it.univaq.di.choreos.ELTS.impl.ModelImpl#getActivityLoops <em>Activity Loops</em>}</li>
 *   <li>{@link it.univaq.di.choreos.ELTS.impl.ModelImpl#getDataTypesDefinition <em>Data Types Definition</em>}</li>
 *   <li>{@link it.univaq.di.choreos.ELTS.impl.ModelImpl#getFaultTypesDefinition <em>Fault Types Definition</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class ModelImpl extends EObjectImpl implements Model {
	/**
	 * The cached value of the '{@link #getStates() <em>States</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getStates()
	 * @generated
	 * @ordered
	 */
	protected EList<State> states;

	/**
	 * The cached value of the '{@link #getForks() <em>Forks</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getForks()
	 * @generated
	 * @ordered
	 */
	protected EList<Fork> forks;

	/**
	 * The cached value of the '{@link #getJoins() <em>Joins</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getJoins()
	 * @generated
	 * @ordered
	 */
	protected EList<Join> joins;

	/**
	 * The cached value of the '{@link #getLabeledTransitions() <em>Labeled Transitions</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getLabeledTransitions()
	 * @generated
	 * @ordered
	 */
	protected EList<LabeledTransition> labeledTransitions;

	/**
	 * The cached value of the '{@link #getEpsilonTransitions() <em>Epsilon Transitions</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getEpsilonTransitions()
	 * @generated
	 * @ordered
	 */
	protected EList<EpsilonTransition> epsilonTransitions;

	/**
	 * The cached value of the '{@link #getInitialState() <em>Initial State</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getInitialState()
	 * @generated
	 * @ordered
	 */
	protected InitialState initialState;

	/**
	 * The cached value of the '{@link #getFinalState() <em>Final State</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getFinalState()
	 * @generated
	 * @ordered
	 */
	protected FinalState finalState;

	/**
	 * The cached value of the '{@link #getOperationsDefinition() <em>Operations Definition</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getOperationsDefinition()
	 * @generated
	 * @ordered
	 */
	protected OperationsDefinition operationsDefinition;

	/**
	 * The cached value of the '{@link #getAlternatives() <em>Alternatives</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getAlternatives()
	 * @generated
	 * @ordered
	 */
	protected EList<Alternative> alternatives;

	/**
	 * The cached value of the '{@link #getActivityLoops() <em>Activity Loops</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getActivityLoops()
	 * @generated
	 * @ordered
	 */
	protected EList<ActivityLoop> activityLoops;

	/**
	 * The cached value of the '{@link #getDataTypesDefinition() <em>Data Types Definition</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getDataTypesDefinition()
	 * @generated
	 * @ordered
	 */
	protected DataTypeDefinition dataTypesDefinition;

	/**
	 * The cached value of the '{@link #getFaultTypesDefinition() <em>Fault Types Definition</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getFaultTypesDefinition()
	 * @generated
	 * @ordered
	 */
	protected FaultTypeDefinition faultTypesDefinition;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ModelImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return ELTSPackage.Literals.MODEL;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<State> getStates() {
		if (states == null) {
			states = new EObjectContainmentEList<State>(State.class, this, ELTSPackage.MODEL__STATES);
		}
		return states;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<Fork> getForks() {
		if (forks == null) {
			forks = new EObjectContainmentEList<Fork>(Fork.class, this, ELTSPackage.MODEL__FORKS);
		}
		return forks;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<Join> getJoins() {
		if (joins == null) {
			joins = new EObjectContainmentEList<Join>(Join.class, this, ELTSPackage.MODEL__JOINS);
		}
		return joins;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<LabeledTransition> getLabeledTransitions() {
		if (labeledTransitions == null) {
			labeledTransitions = new EObjectContainmentEList<LabeledTransition>(LabeledTransition.class, this, ELTSPackage.MODEL__LABELED_TRANSITIONS);
		}
		return labeledTransitions;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<EpsilonTransition> getEpsilonTransitions() {
		if (epsilonTransitions == null) {
			epsilonTransitions = new EObjectContainmentEList<EpsilonTransition>(EpsilonTransition.class, this, ELTSPackage.MODEL__EPSILON_TRANSITIONS);
		}
		return epsilonTransitions;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public InitialState getInitialState() {
		return initialState;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetInitialState(InitialState newInitialState, NotificationChain msgs) {
		InitialState oldInitialState = initialState;
		initialState = newInitialState;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, ELTSPackage.MODEL__INITIAL_STATE, oldInitialState, newInitialState);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setInitialState(InitialState newInitialState) {
		if (newInitialState != initialState) {
			NotificationChain msgs = null;
			if (initialState != null)
				msgs = ((InternalEObject)initialState).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - ELTSPackage.MODEL__INITIAL_STATE, null, msgs);
			if (newInitialState != null)
				msgs = ((InternalEObject)newInitialState).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - ELTSPackage.MODEL__INITIAL_STATE, null, msgs);
			msgs = basicSetInitialState(newInitialState, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ELTSPackage.MODEL__INITIAL_STATE, newInitialState, newInitialState));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public FinalState getFinalState() {
		return finalState;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetFinalState(FinalState newFinalState, NotificationChain msgs) {
		FinalState oldFinalState = finalState;
		finalState = newFinalState;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, ELTSPackage.MODEL__FINAL_STATE, oldFinalState, newFinalState);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setFinalState(FinalState newFinalState) {
		if (newFinalState != finalState) {
			NotificationChain msgs = null;
			if (finalState != null)
				msgs = ((InternalEObject)finalState).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - ELTSPackage.MODEL__FINAL_STATE, null, msgs);
			if (newFinalState != null)
				msgs = ((InternalEObject)newFinalState).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - ELTSPackage.MODEL__FINAL_STATE, null, msgs);
			msgs = basicSetFinalState(newFinalState, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ELTSPackage.MODEL__FINAL_STATE, newFinalState, newFinalState));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public OperationsDefinition getOperationsDefinition() {
		return operationsDefinition;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetOperationsDefinition(OperationsDefinition newOperationsDefinition, NotificationChain msgs) {
		OperationsDefinition oldOperationsDefinition = operationsDefinition;
		operationsDefinition = newOperationsDefinition;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, ELTSPackage.MODEL__OPERATIONS_DEFINITION, oldOperationsDefinition, newOperationsDefinition);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setOperationsDefinition(OperationsDefinition newOperationsDefinition) {
		if (newOperationsDefinition != operationsDefinition) {
			NotificationChain msgs = null;
			if (operationsDefinition != null)
				msgs = ((InternalEObject)operationsDefinition).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - ELTSPackage.MODEL__OPERATIONS_DEFINITION, null, msgs);
			if (newOperationsDefinition != null)
				msgs = ((InternalEObject)newOperationsDefinition).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - ELTSPackage.MODEL__OPERATIONS_DEFINITION, null, msgs);
			msgs = basicSetOperationsDefinition(newOperationsDefinition, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ELTSPackage.MODEL__OPERATIONS_DEFINITION, newOperationsDefinition, newOperationsDefinition));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<Alternative> getAlternatives() {
		if (alternatives == null) {
			alternatives = new EObjectContainmentEList<Alternative>(Alternative.class, this, ELTSPackage.MODEL__ALTERNATIVES);
		}
		return alternatives;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<ActivityLoop> getActivityLoops() {
		if (activityLoops == null) {
			activityLoops = new EObjectContainmentEList<ActivityLoop>(ActivityLoop.class, this, ELTSPackage.MODEL__ACTIVITY_LOOPS);
		}
		return activityLoops;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public DataTypeDefinition getDataTypesDefinition() {
		return dataTypesDefinition;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetDataTypesDefinition(DataTypeDefinition newDataTypesDefinition, NotificationChain msgs) {
		DataTypeDefinition oldDataTypesDefinition = dataTypesDefinition;
		dataTypesDefinition = newDataTypesDefinition;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, ELTSPackage.MODEL__DATA_TYPES_DEFINITION, oldDataTypesDefinition, newDataTypesDefinition);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setDataTypesDefinition(DataTypeDefinition newDataTypesDefinition) {
		if (newDataTypesDefinition != dataTypesDefinition) {
			NotificationChain msgs = null;
			if (dataTypesDefinition != null)
				msgs = ((InternalEObject)dataTypesDefinition).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - ELTSPackage.MODEL__DATA_TYPES_DEFINITION, null, msgs);
			if (newDataTypesDefinition != null)
				msgs = ((InternalEObject)newDataTypesDefinition).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - ELTSPackage.MODEL__DATA_TYPES_DEFINITION, null, msgs);
			msgs = basicSetDataTypesDefinition(newDataTypesDefinition, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ELTSPackage.MODEL__DATA_TYPES_DEFINITION, newDataTypesDefinition, newDataTypesDefinition));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public FaultTypeDefinition getFaultTypesDefinition() {
		return faultTypesDefinition;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetFaultTypesDefinition(FaultTypeDefinition newFaultTypesDefinition, NotificationChain msgs) {
		FaultTypeDefinition oldFaultTypesDefinition = faultTypesDefinition;
		faultTypesDefinition = newFaultTypesDefinition;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, ELTSPackage.MODEL__FAULT_TYPES_DEFINITION, oldFaultTypesDefinition, newFaultTypesDefinition);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setFaultTypesDefinition(FaultTypeDefinition newFaultTypesDefinition) {
		if (newFaultTypesDefinition != faultTypesDefinition) {
			NotificationChain msgs = null;
			if (faultTypesDefinition != null)
				msgs = ((InternalEObject)faultTypesDefinition).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - ELTSPackage.MODEL__FAULT_TYPES_DEFINITION, null, msgs);
			if (newFaultTypesDefinition != null)
				msgs = ((InternalEObject)newFaultTypesDefinition).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - ELTSPackage.MODEL__FAULT_TYPES_DEFINITION, null, msgs);
			msgs = basicSetFaultTypesDefinition(newFaultTypesDefinition, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ELTSPackage.MODEL__FAULT_TYPES_DEFINITION, newFaultTypesDefinition, newFaultTypesDefinition));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case ELTSPackage.MODEL__STATES:
				return ((InternalEList<?>)getStates()).basicRemove(otherEnd, msgs);
			case ELTSPackage.MODEL__FORKS:
				return ((InternalEList<?>)getForks()).basicRemove(otherEnd, msgs);
			case ELTSPackage.MODEL__JOINS:
				return ((InternalEList<?>)getJoins()).basicRemove(otherEnd, msgs);
			case ELTSPackage.MODEL__LABELED_TRANSITIONS:
				return ((InternalEList<?>)getLabeledTransitions()).basicRemove(otherEnd, msgs);
			case ELTSPackage.MODEL__EPSILON_TRANSITIONS:
				return ((InternalEList<?>)getEpsilonTransitions()).basicRemove(otherEnd, msgs);
			case ELTSPackage.MODEL__INITIAL_STATE:
				return basicSetInitialState(null, msgs);
			case ELTSPackage.MODEL__FINAL_STATE:
				return basicSetFinalState(null, msgs);
			case ELTSPackage.MODEL__OPERATIONS_DEFINITION:
				return basicSetOperationsDefinition(null, msgs);
			case ELTSPackage.MODEL__ALTERNATIVES:
				return ((InternalEList<?>)getAlternatives()).basicRemove(otherEnd, msgs);
			case ELTSPackage.MODEL__ACTIVITY_LOOPS:
				return ((InternalEList<?>)getActivityLoops()).basicRemove(otherEnd, msgs);
			case ELTSPackage.MODEL__DATA_TYPES_DEFINITION:
				return basicSetDataTypesDefinition(null, msgs);
			case ELTSPackage.MODEL__FAULT_TYPES_DEFINITION:
				return basicSetFaultTypesDefinition(null, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case ELTSPackage.MODEL__STATES:
				return getStates();
			case ELTSPackage.MODEL__FORKS:
				return getForks();
			case ELTSPackage.MODEL__JOINS:
				return getJoins();
			case ELTSPackage.MODEL__LABELED_TRANSITIONS:
				return getLabeledTransitions();
			case ELTSPackage.MODEL__EPSILON_TRANSITIONS:
				return getEpsilonTransitions();
			case ELTSPackage.MODEL__INITIAL_STATE:
				return getInitialState();
			case ELTSPackage.MODEL__FINAL_STATE:
				return getFinalState();
			case ELTSPackage.MODEL__OPERATIONS_DEFINITION:
				return getOperationsDefinition();
			case ELTSPackage.MODEL__ALTERNATIVES:
				return getAlternatives();
			case ELTSPackage.MODEL__ACTIVITY_LOOPS:
				return getActivityLoops();
			case ELTSPackage.MODEL__DATA_TYPES_DEFINITION:
				return getDataTypesDefinition();
			case ELTSPackage.MODEL__FAULT_TYPES_DEFINITION:
				return getFaultTypesDefinition();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case ELTSPackage.MODEL__STATES:
				getStates().clear();
				getStates().addAll((Collection<? extends State>)newValue);
				return;
			case ELTSPackage.MODEL__FORKS:
				getForks().clear();
				getForks().addAll((Collection<? extends Fork>)newValue);
				return;
			case ELTSPackage.MODEL__JOINS:
				getJoins().clear();
				getJoins().addAll((Collection<? extends Join>)newValue);
				return;
			case ELTSPackage.MODEL__LABELED_TRANSITIONS:
				getLabeledTransitions().clear();
				getLabeledTransitions().addAll((Collection<? extends LabeledTransition>)newValue);
				return;
			case ELTSPackage.MODEL__EPSILON_TRANSITIONS:
				getEpsilonTransitions().clear();
				getEpsilonTransitions().addAll((Collection<? extends EpsilonTransition>)newValue);
				return;
			case ELTSPackage.MODEL__INITIAL_STATE:
				setInitialState((InitialState)newValue);
				return;
			case ELTSPackage.MODEL__FINAL_STATE:
				setFinalState((FinalState)newValue);
				return;
			case ELTSPackage.MODEL__OPERATIONS_DEFINITION:
				setOperationsDefinition((OperationsDefinition)newValue);
				return;
			case ELTSPackage.MODEL__ALTERNATIVES:
				getAlternatives().clear();
				getAlternatives().addAll((Collection<? extends Alternative>)newValue);
				return;
			case ELTSPackage.MODEL__ACTIVITY_LOOPS:
				getActivityLoops().clear();
				getActivityLoops().addAll((Collection<? extends ActivityLoop>)newValue);
				return;
			case ELTSPackage.MODEL__DATA_TYPES_DEFINITION:
				setDataTypesDefinition((DataTypeDefinition)newValue);
				return;
			case ELTSPackage.MODEL__FAULT_TYPES_DEFINITION:
				setFaultTypesDefinition((FaultTypeDefinition)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case ELTSPackage.MODEL__STATES:
				getStates().clear();
				return;
			case ELTSPackage.MODEL__FORKS:
				getForks().clear();
				return;
			case ELTSPackage.MODEL__JOINS:
				getJoins().clear();
				return;
			case ELTSPackage.MODEL__LABELED_TRANSITIONS:
				getLabeledTransitions().clear();
				return;
			case ELTSPackage.MODEL__EPSILON_TRANSITIONS:
				getEpsilonTransitions().clear();
				return;
			case ELTSPackage.MODEL__INITIAL_STATE:
				setInitialState((InitialState)null);
				return;
			case ELTSPackage.MODEL__FINAL_STATE:
				setFinalState((FinalState)null);
				return;
			case ELTSPackage.MODEL__OPERATIONS_DEFINITION:
				setOperationsDefinition((OperationsDefinition)null);
				return;
			case ELTSPackage.MODEL__ALTERNATIVES:
				getAlternatives().clear();
				return;
			case ELTSPackage.MODEL__ACTIVITY_LOOPS:
				getActivityLoops().clear();
				return;
			case ELTSPackage.MODEL__DATA_TYPES_DEFINITION:
				setDataTypesDefinition((DataTypeDefinition)null);
				return;
			case ELTSPackage.MODEL__FAULT_TYPES_DEFINITION:
				setFaultTypesDefinition((FaultTypeDefinition)null);
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case ELTSPackage.MODEL__STATES:
				return states != null && !states.isEmpty();
			case ELTSPackage.MODEL__FORKS:
				return forks != null && !forks.isEmpty();
			case ELTSPackage.MODEL__JOINS:
				return joins != null && !joins.isEmpty();
			case ELTSPackage.MODEL__LABELED_TRANSITIONS:
				return labeledTransitions != null && !labeledTransitions.isEmpty();
			case ELTSPackage.MODEL__EPSILON_TRANSITIONS:
				return epsilonTransitions != null && !epsilonTransitions.isEmpty();
			case ELTSPackage.MODEL__INITIAL_STATE:
				return initialState != null;
			case ELTSPackage.MODEL__FINAL_STATE:
				return finalState != null;
			case ELTSPackage.MODEL__OPERATIONS_DEFINITION:
				return operationsDefinition != null;
			case ELTSPackage.MODEL__ALTERNATIVES:
				return alternatives != null && !alternatives.isEmpty();
			case ELTSPackage.MODEL__ACTIVITY_LOOPS:
				return activityLoops != null && !activityLoops.isEmpty();
			case ELTSPackage.MODEL__DATA_TYPES_DEFINITION:
				return dataTypesDefinition != null;
			case ELTSPackage.MODEL__FAULT_TYPES_DEFINITION:
				return faultTypesDefinition != null;
		}
		return super.eIsSet(featureID);
	}

} //ModelImpl
