/*package it.univaq.di.choreos.bpmn2clts2;

import it.univaq.di.choreos.CLTS.impl.CLTSPackageImpl;
import it.univaq.di.choreos.bpmn2clts.Bpmn2CltsException;
import it.univaq.di.choreos.bpmn2clts.Transformation;

import java.io.File;
import java.io.IOException;

import junit.framework.Assert;

import org.junit.Before;
import org.junit.Test;

public class Bpmn2CltsTrasformationTest {

	private TestUtil util;
	private Transformation transformation;
	
	@Before
	public void setUp() {
		CLTSPackageImpl.init();
		transformation = new Transformation();
		util = new TestUtil();
	}
	
	@Test
	public void test01() throws IOException, Bpmn2CltsException {
		String bpmnIn = "test_resources"+File.separatorChar+"test_01"+File.separatorChar+"in_bpmn"+File.separatorChar+"test_01.bpmn2";
		String cltsExpectedPath = "test_resources"+File.separatorChar+"test_01"+File.separatorChar+"out_clts"+File.separatorChar+"test_01.clts";
		//run simulation for check model are equals
		Assert.assertTrue(util.isSimulated(transformation.transform(bpmnIn), cltsExpectedPath)); 
	}

	@Test
	public void test02() throws IOException, Bpmn2CltsException {
		String bpmnIn = "test_resources"+File.separatorChar+"test_02"+File.separatorChar+"in_bpmn"+File.separatorChar+"test_02.bpmn2";
		String cltsExpectedPath = "test_resources"+File.separatorChar+"test_02"+File.separatorChar+"out_clts"+File.separatorChar+"test_02.clts";
		Assert.assertTrue(util.isSimulated(transformation.transform(bpmnIn), cltsExpectedPath));
	}
	
	@Test
	public void test03() throws IOException, Bpmn2CltsException {
		String bpmnIn = "test_resources"+File.separatorChar+"test_03"+File.separatorChar+"in_bpmn"+File.separatorChar+"test_03.bpmn2";
		String cltsExpectedPath = "test_resources"+File.separatorChar+"test_03"+File.separatorChar+"out_clts"+File.separatorChar+"test_03.clts";
		Assert.assertTrue(util.isSimulated(transformation.transform(bpmnIn), cltsExpectedPath));
	}
	
	@Test
	public void test04() throws IOException {
		String bpmnIn = "test_resources"+File.separatorChar+"test_04"+File.separatorChar+"in_bpmn"+File.separatorChar+"test_04.bpmn2";
		String cltsExpectedPath = "test_resources"+File.separatorChar+"test_04"+File.separatorChar+"out_clts"+File.separatorChar+"test_04.clts";
		String BPMNModelIn = FileUtils.readFileToString(new File(bpmnIn));
		String resutltStep1 = bpmn2clts.transform(BPMNModelIn);
		String CLTSresutltStep2 = clts2clts.transform(resutltStep1);
		//run simulation for check model are equals
		Assert.assertTrue(util.isSimulated(CLTSresutltStep2, cltsExpectedPath)); 
	}
	
	@Test
	public void test05() throws IOException, Bpmn2CltsException {
		String bpmnIn = "test_resources"+File.separatorChar+"test_05"+File.separatorChar+"in_bpmn"+File.separatorChar+"test_05.bpmn2";
		String cltsExpectedPath = "test_resources"+File.separatorChar+"test_05"+File.separatorChar+"out_clts"+File.separatorChar+"test_05.clts";
		Assert.assertTrue(util.isSimulated(transformation.transform(bpmnIn), cltsExpectedPath));
	}
	
	@Test
	public void test06() throws IOException, Bpmn2CltsException {
		String bpmnIn = "test_resources"+File.separatorChar+"test_06"+File.separatorChar+"in_bpmn"+File.separatorChar+"test_06.bpmn2";
		String cltsExpectedPath = "test_resources"+File.separatorChar+"test_06"+File.separatorChar+"out_clts"+File.separatorChar+"test_06.clts";
		Assert.assertTrue(util.isSimulated(transformation.transform(bpmnIn), cltsExpectedPath));
	}
	
	@Test
	public void test07() throws IOException, Bpmn2CltsException {
		String bpmnIn = "test_resources"+File.separatorChar+"test_07"+File.separatorChar+"in_bpmn"+File.separatorChar+"test_07.bpmn2";
		String cltsExpectedPath = "test_resources"+File.separatorChar+"test_07"+File.separatorChar+"out_clts"+File.separatorChar+"test_07.clts";
		Assert.assertTrue(util.isSimulated(transformation.transform(bpmnIn), cltsExpectedPath));
	}
	
	@Test
	public void test08() throws IOException, Bpmn2CltsException {
		String bpmnIn = "test_resources"+File.separatorChar+"test_08"+File.separatorChar+"in_bpmn"+File.separatorChar+"test_08.bpmn2";
		String cltsExpectedPath = "test_resources"+File.separatorChar+"test_08"+File.separatorChar+"out_clts"+File.separatorChar+"test_08.clts";
		Assert.assertTrue(util.isSimulated(transformation.transform(bpmnIn), cltsExpectedPath)); 
	}
	
	@Test
	public void test09() throws IOException, Bpmn2CltsException {
		String bpmnIn = "test_resources"+File.separatorChar+"test_09"+File.separatorChar+"in_bpmn"+File.separatorChar+"choreography_C7.bpmn2";
		String cltsExpectedPath = "test_resources"+File.separatorChar+"test_09"+File.separatorChar+"out_clts"+File.separatorChar+"wp7.clts";
		Assert.assertTrue(util.isSimulated(transformation.transform(bpmnIn), cltsExpectedPath)); 
	
	}

}
*/