package it.univaq.di.choreos.coordderivator;

public class TupleStored {
	private String source;
	private String target;
	private String condition;
	private String coord;
	
	public TupleStored(String source, String target, String condition, String coord) {
		super();
		this.source = source;
		this.target = target;
		this.condition = condition;
		this.coord = coord;
	}

	public String getSource() {
		return source;
	}

	public void setSource(String source) {
		this.source = source;
	}

	public String getTarget() {
		return target;
	}

	public void setTarget(String target) {
		this.target = target;
	}

	public String getCondition() {
		return condition;
	}

	public void setCondition(String condition) {
		this.condition = condition;
	}

	public String getCoord() {
		return coord;
	}

	public void setCoord(String coord) {
		this.coord = coord;
	}

	
	@Override
	public boolean equals(Object tp) {
        if (tp == this) {
            return true;
        }
        if (!(tp instanceof TupleStored)) {
            return false;
        }
        TupleStored tupleStored = (TupleStored) tp;
        return tupleStored.getSource().equals(source) && 
        		tupleStored.getTarget().equals(target) &&
        		tupleStored.getCondition().equals(condition) &&
        		tupleStored.getCoord().equals(coord);
    }

}
