package it.univaq.di.choreos.coordderivator;

import java.io.File;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

import it.univaq.di.choreos.CLTS.impl.CLTSPackageImpl;
import it.univaq.di.choreos.coordderivator.util.CoordUtilTest;
import it.univaq.di.choreos.coordinationprotocol.algorithm.model.coordmetamodel.Coord;
import it.univaq.di.choreos.coordinationprotocol.algorithm.model.coordmetamodel.impl.CoordmetamodelPackageImpl;

import org.eclipse.emf.common.util.URI;
import org.eclipse.emf.ecore.resource.Resource;
import org.eclipse.emf.ecore.xmi.impl.XMIResourceFactoryImpl;
import org.junit.*;

public class CoordDerivatorTest {

	private String resourcesRoot="." + File.separator + "src" + File.separator + "test" + File.separator + "resources";
	/*
	@Before
	public void setUp() {
		CoordmetamodelPackageImpl.init();

		CLTSPackageImpl.init();
	}

	@Test
	public void test01() throws IOException {
		String clts = resourcesRoot + File.separator + "test_01" + File.separator + "clts" + File.separator + "test_01.clts";
		String coord = resourcesRoot + File.separator + "test_01" + File.separator + "coord" + File.separator;

		List<Coord> coordModelsExpected = getAllCoord(coord);
		it.univaq.di.choreos.CLTS.Model cltsModel = loadCLTSModel(clts);

		CoordDerivator cdd = new CoordDerivator(cltsModel);
		cdd.init();
		List<Coord> coordModelsResult = cdd.getCoords();

		Assert.assertTrue(CoordUtilTest.isEquals(coordModelsExpected, coordModelsResult));
	}

	@Test
	public void test02() throws IOException {
		String clts = resourcesRoot + File.separator + "test_02" + File.separator + "clts" + File.separator + "test_02.clts";
		String coord = resourcesRoot + File.separator + "test_02" + File.separator + "coord" + File.separator;

		List<Coord> coordModelsExpected = getAllCoord(coord);
		it.univaq.di.choreos.CLTS.Model cltsModel = loadCLTSModel(clts);

		CoordDerivator cdd = new CoordDerivator(cltsModel);
		cdd.init();
		List<Coord> coordModelsResult = cdd.getCoords();

		Assert.assertTrue(CoordUtilTest.isEquals(coordModelsExpected, coordModelsResult));
	}

	@Test
	public void test03() throws IOException {
		String clts = resourcesRoot + File.separator + "test_03" + File.separator + "clts" + File.separator + "test_03.clts";
		String coord = resourcesRoot + File.separator + "test_03" + File.separator + "coord" + File.separator;

		List<Coord> coordModelsExpected = getAllCoord(coord);
		it.univaq.di.choreos.CLTS.Model cltsModel = loadCLTSModel(clts);

		CoordDerivator cdd = new CoordDerivator(cltsModel);
		cdd.init();
		List<Coord> coordModelsResult = cdd.getCoords();

		Assert.assertTrue(CoordUtilTest.isEquals(coordModelsExpected, coordModelsResult));
	}

	@Test
	public void test04() throws IOException {
		String clts = resourcesRoot + File.separator + "test_04" + File.separator + "clts" + File.separator + "test_04.clts";
		String coord = resourcesRoot + File.separator + "test_04" + File.separator + "coord" + File.separator;

		List<Coord> coordModelsExpected = getAllCoord(coord);
		it.univaq.di.choreos.CLTS.Model cltsModel = loadCLTSModel(clts);

		CoordDerivator cdd = new CoordDerivator(cltsModel);
		cdd.init();
		List<Coord> coordModelsResult = cdd.getCoords();

		Assert.assertTrue(CoordUtilTest.isEquals(coordModelsExpected, coordModelsResult));
	}

	@Test
	public void test05() throws IOException {
		String clts = resourcesRoot + File.separator + "test_05" + File.separator + "clts" + File.separator + "test_05.clts";
		String coord = resourcesRoot + File.separator + "test_05" + File.separator + "coord" + File.separator;

		List<Coord> coordModelsExpected = getAllCoord(coord);
		it.univaq.di.choreos.CLTS.Model cltsModel = loadCLTSModel(clts);

		CoordDerivator cdd = new CoordDerivator(cltsModel);
		cdd.init();
		List<Coord> coordModelsResult = cdd.getCoords();

		Assert.assertTrue(CoordUtilTest.isEquals(coordModelsExpected, coordModelsResult));
	}

	@Test
	public void test06() throws IOException {
		String clts = resourcesRoot + File.separator + "test_06" + File.separator + "clts" + File.separator + "test_06.clts";
		String coord = resourcesRoot + File.separator + "test_06" + File.separator + "coord" + File.separator;

		List<Coord> coordModelsExpected = getAllCoord(coord);
		it.univaq.di.choreos.CLTS.Model cltsModel = loadCLTSModel(clts);

		CoordDerivator cdd = new CoordDerivator(cltsModel);
		cdd.init();
		List<Coord> coordModelsResult = cdd.getCoords();

		Assert.assertTrue(CoordUtilTest.isEquals(coordModelsExpected, coordModelsResult));
	}

	@Test
	public void test07() throws IOException {
		String clts = resourcesRoot + File.separator + "test_07" + File.separator + "clts" + File.separator + "test_07.clts";
		String coord = resourcesRoot + File.separator + "test_07" + File.separator + "coord" + File.separator;

		List<Coord> coordModelsExpected = getAllCoord(coord);
		it.univaq.di.choreos.CLTS.Model cltsModel = loadCLTSModel(clts);

		CoordDerivator cdd = new CoordDerivator(cltsModel);
		cdd.init();
		List<Coord> coordModelsResult = cdd.getCoords();

		Assert.assertTrue(CoordUtilTest.isEquals(coordModelsExpected, coordModelsResult));
	}

	@Test
	public void test08() throws IOException {
		String clts = resourcesRoot + File.separator + "test_08" + File.separator + "clts" + File.separator + "test_08.clts";
		String coord = resourcesRoot + File.separator + "test_08" + File.separator + "coord" + File.separator;

		List<Coord> coordModelsExpected = getAllCoord(coord);
		it.univaq.di.choreos.CLTS.Model cltsModel = loadCLTSModel(clts);

		CoordDerivator cdd = new CoordDerivator(cltsModel);
		cdd.init();
		List<Coord> coordModelsResult = cdd.getCoords();

		Assert.assertTrue(CoordUtilTest.isEquals(coordModelsExpected, coordModelsResult));
	}

	@Test
	public void test08_fake() throws IOException {
		String clts = resourcesRoot + File.separator + "test_08_fake" + File.separator + "clts" + File.separator + "test_08.clts";
		String coord = resourcesRoot + File.separator + "test_08_fake" + File.separator + "coord" + File.separator;

		List<Coord> coordModelsExpected = getAllCoord(coord);
		it.univaq.di.choreos.CLTS.Model cltsModel = loadCLTSModel(clts);

		CoordDerivator cdd = new CoordDerivator(cltsModel);
		cdd.init();
		List<Coord> coordModelsResult = cdd.getCoords();

		Assert.assertFalse(CoordUtilTest.isEquals(coordModelsExpected, coordModelsResult));
	}
*/	
/*
	@Test
	public void test09() throws IOException {
		String clts = resourcesRoot + File.separator + "test_09" + File.separator + "clts" + File.separator + "test_09.clts";
		String coord = resourcesRoot + File.separator + "test_09" + File.separator + "coord" + File.separator;

		List<Coord> coordModelsExpected = getAllCoord(coord);
		it.univaq.di.choreos.CLTS.Model cltsModel = loadCLTSModel(clts);

		CoordDerivator cdd = new CoordDerivator(cltsModel);
		cdd.init();
		List<Coord> coordModelsResult = cdd.getCoordsModel();

		Assert.assertTrue(CoordUtilTest.isEquals(coordModelsExpected, coordModelsResult));
	}

	@Test
	public void test10() throws IOException {
		String clts = resourcesRoot + File.separator + "test_10" + File.separator + "clts" + File.separator + "test_10.clts";
		String coord = resourcesRoot + File.separator + "test_10" + File.separator + "coord" + File.separator;

		List<Coord> coordModelsExpected = getAllCoord(coord);
		it.univaq.di.choreos.CLTS.Model cltsModel = loadCLTSModel(clts);

		CoordDerivator cdd = new CoordDerivator(cltsModel);
		cdd.init();
		List<Coord> coordModelsResult = cdd.getCoordsModel();

		Assert.assertTrue(CoordUtilTest.isEquals(coordModelsExpected, coordModelsResult));
	}
*/
/*
	@Test
	public void test11() throws IOException {
		String clts = resourcesRoot + File.separator + "test_11" + File.separator + "clts" + File.separator + "test_11.clts";
		String coord = resourcesRoot + File.separator + "test_11" + File.separator + "coord" + File.separator;

		List<Coord> coordModelsExpected = getAllCoord(coord);
		it.univaq.di.choreos.CLTS.Model cltsModel = loadCLTSModel(clts);

		CoordDerivator cdd = new CoordDerivator(cltsModel);
		cdd.init();
		List<Coord> coordModelsResult = cdd.getCoords();

		Assert.assertTrue(CoordUtilTest.isEquals(coordModelsExpected, coordModelsResult));
	}

	@Test
	public void test12() throws IOException {
		String clts = resourcesRoot + File.separator + "test_12" + File.separator + "clts" + File.separator + "test_12.clts";
		String coord = resourcesRoot + File.separator + "test_12" + File.separator + "coord" + File.separator;

		List<Coord> coordModelsExpected = getAllCoord(coord);
		it.univaq.di.choreos.CLTS.Model cltsModel = loadCLTSModel(clts);

		CoordDerivator cdd = new CoordDerivator(cltsModel);
		cdd.init();
		List<Coord> coordModelsResult = cdd.getCoords();
		Assert.assertTrue(CoordUtilTest.isEquals(coordModelsExpected, coordModelsResult));
	}

	@Test
	public void testwp6() throws IOException {
		String clts = resourcesRoot + File.separator + "test_wp6" + File.separator + "clts" + File.separator + "test_wp6.clts";
		String coord = resourcesRoot + File.separator + "test_wp6" + File.separator + "coord" + File.separator;

		List<Coord> coordModelsExpected = getAllCoord(coord);
		it.univaq.di.choreos.CLTS.Model cltsModel = loadCLTSModel(clts);

		CoordDerivator cdd = new CoordDerivator(cltsModel);
		cdd.init();
		List<Coord> coordModelsResult = cdd.getCoords();
		Assert.assertTrue(CoordUtilTest.isEquals(coordModelsExpected, coordModelsResult));
	}

	@Test
	public void test14() throws IOException {
		String clts = resourcesRoot + File.separator + "test_14" + File.separator + "clts" + File.separator + "test_14.clts";
		String coord = resourcesRoot + File.separator + "test_14" + File.separator + "coord" + File.separator;

		List<Coord> coordModelsExpected = getAllCoord(coord);
		it.univaq.di.choreos.CLTS.Model cltsModel = loadCLTSModel(clts);

		CoordDerivator cdd = new CoordDerivator(cltsModel);
		cdd.init();
		List<Coord> coordModelsResult = cdd.getCoords();
		Assert.assertTrue(CoordUtilTest.isEquals(coordModelsExpected, coordModelsResult));
	}

	private Coord loadCoordModel(String fileNameModel) throws IOException {
		// get fileURI to Models
		URI fileURIModel = URI.createFileURI(fileNameModel);

		// create resource from the Models
		Resource resourceModel = new XMIResourceFactoryImpl().createResource(fileURIModel);
		resourceModel.load(null);

		if (resourceModel.getContents().get(0) instanceof Coord) {
			// get model
			return (Coord) resourceModel.getContents().get(0);
		}

		return null;
	}

	private List<Coord> getAllCoord(String entryCoord) throws IOException {
		List<Coord> models = new ArrayList<Coord>();
		File fileEntryCoord = new File(entryCoord);

		if (fileEntryCoord.isDirectory()) {
			for (File fileUri : fileEntryCoord.listFiles()) {
				models.add(loadCoordModel(fileUri.getAbsolutePath()));
			}
		}

		return models;
	}

	private it.univaq.di.choreos.CLTS.Model loadCLTSModel(String fileNameModel) throws IOException {
		// get fileURI to Models
		URI fileURIModel = URI.createFileURI(fileNameModel);

		// create resource from the Models
		Resource resourceModel = new XMIResourceFactoryImpl().createResource(fileURIModel);
		resourceModel.load(null);

		if (resourceModel.getContents().get(0) instanceof it.univaq.di.choreos.CLTS.Model) {
			// get model
			return (it.univaq.di.choreos.CLTS.Model) resourceModel.getContents().get(0);
		}

		return null;
	}
	*/
	
	
}
