package it.univaq.di.choreos.stockconfirm;

import javax.jws.Oneway;
import javax.jws.WebMethod;
import javax.jws.WebParam;
import javax.jws.WebService;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

@WebService( serviceName="StockConfirm", targetNamespace="http://choreos.di.univaq.it", portName="StockConfirmPort" )
public class StockConfirm {

	final Logger logger = LoggerFactory.getLogger(StockConfirm.class);
	
	@WebMethod( operationName="orderconfirm" )
	@Oneway
	public void orderconfirm( @WebParam( name="orderNumber" ) String orderNumber, @WebParam( name="quantity" ) int quantity ) {
		logger.debug("received orderconfirm");
	}
}
