package it.univaq.di.choreos.synthesis.cdgenerator.rest.client;

import it.univaq.di.choreos.synthesis.cdgenerator.CDGenerator;
import it.univaq.di.choreos.synthesis.cdgenerator.CDGeneratorException;
import it.univaq.di.choreos.synthesis.datamodel.CD;

import javax.ws.rs.WebApplicationException;
import javax.ws.rs.core.Response;

import org.apache.cxf.jaxrs.client.WebClient;
import org.apache.cxf.transport.http.HTTPConduit;
import org.apache.cxf.transports.http.configuration.HTTPClientPolicy;

public class CDGeneratorClient implements CDGenerator {
	
	private String host;

	public CDGeneratorClient(String host) {
		this.host = host;
	}
	
	public String generate(CD cd) throws CDGeneratorException {

		WebClient client = setupClient();
		client.path("generate");
		try {
			Response response = client.post(cd);
			String location = (String) response.getMetadata().get("location").get(0);
			return location;
			//return client.post(cd, String.class);

		} catch (WebApplicationException e) {
			throw new CDGeneratorException();
		}
		
	}

	private WebClient setupClient() {

		WebClient client = WebClient.create(host);

		// remove time out
		// not proud of it!
		HTTPConduit http = (HTTPConduit) WebClient.getConfig(client).getConduit();
		HTTPClientPolicy httpClientPolicy = new HTTPClientPolicy();
		httpClientPolicy.setConnectionTimeout(0);// indefined
		httpClientPolicy.setReceiveTimeout(0);// indefined
		http.setClient(httpClientPolicy);

		return client;
	}

	@Override
	public byte[] getCD(String choreographyName, String cdDir, String cdName) throws CDGeneratorException {
//TODO
		return null;
	
	}



}
