package it.univaq.di.choreos.synthesis.datamodel;

import java.util.ArrayList;
import java.util.List;

import javax.xml.bind.annotation.XmlRootElement;

@XmlRootElement
public class Participant implements java.io.Serializable {
	
	private String name;
	
	private List<CoordModel> coordModels;
	
	public Participant() {
		super();
		coordModels = new ArrayList<CoordModel>();
	}

	public String getName() {
		return name;
	}

	public void setName(String name) {
		this.name = name;
	}
	
	public List<CoordModel> getCoordModels() {
		return coordModels;
	}


	public void setCoordModels(List<CoordModel> coordModels) {
		this.coordModels = coordModels;
	}


	@Override
	public String toString() {
		return name;
	}

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + ((name == null) ? 0 : name.hashCode());
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		Participant other = (Participant) obj;
		if (name == null) {
			if (other.name != null)
				return false;
		} else if (!name.equals(other.name))
			return false;
		return true;
	}


	
	
}
