package it.univaq.di.choreos.synthesis.m2mtransformator.rest;

import it.univaq.di.choreos.synthesis.datamodel.AbstractParticipant;
import it.univaq.di.choreos.synthesis.datamodel.CLTSModel;

import java.util.List;

import javax.xml.bind.annotation.XmlRootElement;

@XmlRootElement
public class Abstract2ConcreteCLTSModel implements java.io.Serializable {

	private CLTSModel cltsModel;
	private List<AbstractParticipant> participants;

	public Abstract2ConcreteCLTSModel() {
		super();
	}

	public Abstract2ConcreteCLTSModel(CLTSModel cltsModel, List<AbstractParticipant> participants) {
		super();
		this.cltsModel = cltsModel;
		this.participants = participants;
	}

	public CLTSModel getCltsModel() {
		return cltsModel;
	}

	public void setCltsModel(CLTSModel cltsModel) {
		this.cltsModel = cltsModel;
	}

	public List<AbstractParticipant> getParticipants() {
		return participants;
	}

	public void setParticipants(List<AbstractParticipant> participants) {
		this.participants = participants;
	}

}
