package it.univaq.di.choreos.synthesis.synthesisprocessor.dummies.test01;

import it.univaq.di.choreos.synthesis.datamodel.AbstractParticipant;
import it.univaq.di.choreos.synthesis.datamodel.CLTSModel;
import it.univaq.di.choreos.synthesis.datamodel.ChoreographyBPMNSpecification;
import it.univaq.di.choreos.synthesis.datamodel.Participant;
import it.univaq.di.choreos.synthesis.m2mtransformator.M2MTransformator;
import it.univaq.di.choreos.synthesis.m2mtransformator.M2MTransformatorException;

import java.util.List;

public class DummyM2MTransformator implements M2MTransformator {

	private CLTSModel cltsModel;
	private List<Participant> participants;

	public DummyM2MTransformator(CLTSModel cltsModel, List<Participant> participants) {
		this.cltsModel = cltsModel;
		this.participants = participants;
	}

	public CLTSModel bpmn2clts(ChoreographyBPMNSpecification bpmnchoreographyspecification) throws M2MTransformatorException {
		return cltsModel;
	}

	@Override
	public List<Participant> clts2coords(CLTSModel cltsModel) throws M2MTransformatorException {
		return participants;
	}

	@Override
	public CLTSModel abstract2ConcreteCLTSModel(CLTSModel cltsModel, List<AbstractParticipant> participants) throws M2MTransformatorException {
		return cltsModel;
	}

}
